<script lang="ts">
    import { config } from '../graph/simulation'
    import type { Config } from '../graph/simulation'

    interface ConfigField {
        label: string
        key: keyof Config
        delta: number
    }

    const configFields: ConfigField[] = [
        { label: 'Node charge strength', key: 'chargeStrength', delta: 100 },
        { label: 'Node charge dist max', key: 'chargeDistanceMax', delta: 10 },
        { label: 'Link min distance', key: 'minDistance', delta: 10 },
        { label: 'Link max distance', key: 'maxDistance', delta: 10 },
        { label: 'Center strength', key: 'centerStrength', delta: 0.01 },
    ]

    function change(key: keyof Config, delta: number) {
        config.update((c) => ({ ...c, [key]: (Number(c[key]) || 0) + delta }))
    }
</script>

<div class="grid grid-flow-col grid-cols-3 grid-rows-2 justify-items-center">
    {#each configFields as { label, key, delta }}
        <div>
            <div class="font-bold">{label}</div>
            <div class="whitespace-nowrap mb-2">
                <button on:click={() => change(key, delta)}>+{delta}</button>
                <input type="text" bind:value={$config[key]}>
                <button on:click={() => change(key, -delta)}>-{delta}</button>
            </div>
        </div>
    {/each}

</div>

<style>
    button {
        @apply bg-donkerblauw text-white p-2;
    }

    input {
        @apply border border-grijs-4 p-2 w-20 text-center;
    }
</style>